# Contributing

Hey! Many thanks for wanting to develop, improve and contribute to PyperCard.

PyperCard reflects the colourful and diverse backgrounds, cultures and
interests of our community. As a result, our
[Code of Conduct](code_of_conduct.md) is an expression of what you can expect
from us and what we hope from you as we find ourselves _being together_ in a
collaborative online space.

Put simply, we want to welcome you to our community so we all flourish and
benefit from each other's experiences, perspectives and contributions.

If you're thinking, _"but they don't mean me"_, then we especially mean
_**YOU**_.

* If you're from a background **that isn't usually well-represented** in most
  technical communities, get involved - _we want to help you make a
  difference_.
* If you're from a background **that is well-represented** in most technical
  groups, get involved - _we want your help in making a difference_.
* If you're **worried about not being technical enough**, get involved - _your
  fresh perspective will be invaluable_.
* If you think **you're an imposter**, join us - _many of the PyperCard
  contributors feel this way_.
* This is a **volunteer led community**, so join us - _you will be welcomed
  with friendship, support and compassion_.

## Reporting bugs

Bugs are tracked on the
[project issues page](https://github.com/pyscript/pypercard/issues). Please
check if your issue has already been filed by someone else by searching the
existing issues before filing a new one. Once your issue is filed, it will be
triaged by another contributor or maintainer. If there are questions raised
about your issue, please respond promptly.

## Creating useful issues

* Use a clear and descriptive title.
* Describe the specific steps that reproduce the problem with as many details
  as possible so that someone can verify the issue.
* Describe the behavior you observed, and the behavior you expected.
* Include screenshots, if they help make the issue clear.

## Reporting security issues

If you aren't confident that it is appropriate to submit a security issue using
the above process, you can e-mail it to <security@pyscript.net>

## License terms for contributions

This Project welcomes contributions, suggestions, and feedback. All
contributions, suggestions, and feedback you submit are accepted under the
[Apache 2.0](license.md) license. You represent that if you do not own
copyright in the code that you have the authority to submit it under the
[Apache 2.0](license.md) license. All feedback, suggestions, or contributions
are not confidential.

Feedback may be given for contributions and, where necessary, changes will be
politely requested and discussed with the originating author. Respectful yet
robust discussion offered in a spirit of growth is most welcome.

## Checklist

* Your code should be commented in plain English (British spelling).
* If your contribution is for a major block of work and you've not done so
  already, add yourself to the `AUTHORS` file in the root of the project and
  the `authors.md` file in the docs directory, following the convention found
  therein.
* We have very comprehensive test coverage - include tests to maintain this!
* Before submitting code ensure coding standards and test coverage by running:

```
make clean
make tidy
make lint
```

* If in doubt, ask a question. The only stupid question is the one that's
  never asked.
* Most importantly, **have fun!**.
